#include <IRremote.h>


//Eingangs-Pin vom Infrarot-Empfänger.
const int Pin_Empfaenger = A0;

//Pin zur Ansteuerung der LED
const int Pin_LED = 13;

//Definiere IR-Codes, mit denen die LED ein- aus- und
//umgeschaltet werden kann
const unsigned long Code_Einschalten = 0x3AC5;
const unsigned long Code_Ausschalten = 0xFFFFBA45;
const unsigned long Code_Umschalten = 0xFFFF827D;

//Objekt, dass für die Verarbeitung der Infrarot-Signale
//zuständig ist.
IR_Empfaenger IR_Empfaenger(Pin_Empfaenger);

//Objekt, in welchem die verarbeiteten Infrarot-Signale //stehen.
decode_results results;


void setup(){
  //Initialisiere die Verbindung zu einem PC.
  Serial.begin(9600);

  //Bereite die LED vor.
  pinMode(Pin_LED, OUTPUT);
  digitalWrite(Pin_LED, LOW);

  //Initialisiere den Infrarot-Empfänger.
  IR_Empfaenger.enableIRIn();
}

void loop() {
  //Wenn der Infrarot-Empfänger etwas gefunden hat, dann
  //speichere dies unter „results“
  if (IR_Empfaenger.decode(&results)) {
    int Code = results.value;
    //Gib aus, welcher Code empfangen wurde.
    printResults(results);

    //Schaue, ob ein Code für das Einschalten des Lichts empfangen wurde.
    if (Code == Code_Einschalten) {
      Serial.println("Schalte jetzt das Licht ein!");
      digitalWrite(Pin_LED, HIGH);
    }

    //Schaue, ob ein Code für das Ausschalten des Lichts empfangen wurde.
    if (Code == Code_Ausschalten) {
      Serial.println("Schalte jetzt das Licht aus!");
      digitalWrite(Pin_LED, LOW);
    }
  }

  //Schaue, ob ein Code für das Umschalten des Lichts empfangen wurde.
  if (Code == Code_Umschalten[i]) {
    Serial.println("Schalte jetzt das Licht um!");
    digitalWrite(Pin_LED, !digitalRead(Pin_LED));
    //Warte, damit mehrmalige kurz hintereinander
    //folgende Signale nicht zu einem Flackern führen.
    delay(500);
  }
}
IR_Empfaenger.resume(); //Warte auf das nächste Signal
}
}

void printResults(decode_results results) {

  //Gebe empfangenen Wert aus.
  Serial.print("Empfangen: 0x");
  Serial.print(results.value, HEX);

  //Gebe den Code-Standard aus, in dem gesendet wurde.
  Serial.print(", Standard:");
  switch (results.decode_type) {
    case NEC:
      Serial.print("NEC");
      break;
    case SONY:
      Serial.print("SONY");
      break;
    case RC5:
      Serial.print("RC5");
      break;
    case RC6:
      Serial.print("RC6");
      break;
    case DISH:
      Serial.print("DISH");
      break;
    case SHARP:
      Serial.print("SHARP");
      break;
    case PANASONIC:
      Serial.print("PANASONIC");
      break;
    case JVC:
      Serial.print("JVC");
      break;
    case SANYO:
      Serial.print("SANYO");
      break;
    case MITSUBISHI:
      Serial.print("MITSUBISHI");
      break;
    default:
      Serial.print("unbekannt");
  }

  //Gebe die Anzahl der empfangenen bits aus.
  Serial.print(", Empfangene Bits: ");
  Serial.println(results.bits);
}
