#include "FastLED.h"

const int Anzahl_LEDs    = 30;
const int AnschlusPin    = 3;
const int Ausblendfaktor = 25;   // 25 / 256 = 10%
const int Verzoegerung   = 30;   // in Millisekunden

CRGB LEDs[Anzahl_LEDs];    //Ein Array für die LEDs definieren

void setup() {
  //Initialisierung der Library
  FastLED.addLeds<WS2812B, AnschlusPin, RGB>(LEDs, Anzahl_LEDs);
}

boolean Richtung = false;
boolean Position = 0;
byte Hue = 0;

void loop() {

  //Richtungswechsel berücksichtigen
  if (Position == 0) {
    Richtung = false;
  } else if (Position == Anzahl_LEDs - 1) {
    Richtung = true;
  }

  //Abhängig von Richtung eine LED weiter oder zurück gehen
  if (Richtung == true) {
    Position--;
  } else {
    Position++;
  }

  // Alle LEDs um 10% dimmen
  for (int i = 0; i < Anzahl_LEDs; i++) {
    LEDs[i].fadeLightBy(Ausblendfaktor);
  }

  LEDs[Position].setHSV(Hue++, 255, 255);  //Hellste LED setzen

  FastLED.show();                          //Daten an LED-Streifen übertragen
  delay(Verzoegerung);                     //Ein bisschen warten

}
