/* Robot Compass

 The robot has an on-board compass module, with
 which it can tell the direction the robot is
 facing. This sketch will make sure the robot
 goes towards a certain direction.

 Beware, magnets will interfere with the compass
 readings.

 Circuit:
 * Arduino Robot

 created 1 May 2013
 by X. Yang
 modified 12 May 2013
 by D. Cuartielles

 This example is in the public domain
*/

// include the robot library
#include <ArduinoRobot.h>
#include <Wire.h>
#include <SPI.h>

int speedLeft;
int speedRight;
int compassValue;
int direc = 180;  //Direction the robot is heading
bool melodyplayed = false;
uint8_t speed = 80;
int direction = 0;
int target = 180;

void setup() {
  // initialize the modules
  Robot.begin();
  Robot.beginTFT();
//  Robot.beginSD();
//  Robot.displayLogos();
  Robot.beginSpeaker();//
  melodyplayed = false;
}

void loop() {
  int currentAngle = Robot.compassRead();
  Robot.drawCompass(currentAngle);
  int diff = target - currentAngle;
  direction = 180 - (diff + 360) % 360;
  if (direction > 0) {
    Robot.motorsWrite(speed, -speed); //right
    delay(10);
  } else {
    Robot.motorsWrite(-speed, speed); //left
    delay(10);
  }

  if (abs(diff) < 5) {
    if (melodyplayed == false) {
      char aTinyMelody[] = "8CE";// This is what we will play
      Robot.playMelody(aTinyMelody);// Play the melody
      Robot.motorsStop();
      melodyplayed = true;
    }
  }
  else {
    melodyplayed = false;
  }

}














/*



//  Robot.pointTo(0);

compassValue = abs(Robot.compassRead());
if (melodyplayed == false) {
  if (compassValue < 5) {
    melodyplayed = true;
  }
}
if (compassValue > 5) {
  melodyplayed = false;
}
}*/
/*
  // read the compass orientation


  compassValue = Robot.compassRead();

  // how many degrees are we off
  int diff = compassValue - direc;

  // modify degress
  if (diff > 180)
    diff = -360 + diff;
  else if (diff < -180)
    diff = 360 + diff;

  // Make the robot turn to its proper orientation
  diff = map(diff, -180, 180, -255, 255);

  if (diff > 0) {
    // keep the right wheel spinning,
    // change the speed of the left wheel
    speedLeft = diff;
    speedRight = -diff * -1;
  } else {
    // keep the right left spinning,
    // change the speed of the left wheel
    speedLeft = diff * -1;
    speedRight = diff;
  }
  // write out to the motors
  Robot.motorsWrite(speedLeft, speedRight);

  // draw the orientation on the screen
*/

