#include <ArduinoRobot.h>
#include <Wire.h>
#include <SPI.h>

void setup() {
  Robot.begin();      //Roboter initialisieren
  Serial.begin(9600); //Serieller Port initialisieren
}


//Globale Variablen für die zuletzt gewählte Geschwindigkeit
int LGeschw = 0; 
int RGeschw = 0;

void loop() {
  //Geschwindigkeit anhand des Potentiometers setzen
  int Geschwindigkeit = map( Robot.knobRead(), 0, 1024, 0, 255);
  
  Robot.updateIR(); //Infrarot-Sensoren einlesen

  //Minimaler Wert aller Sensoren und dazugehörigen Sensor finden
  int Min = 1024;
  int MinPos = -1; // 1 = rechts, 5 = links
  for (int i = 0; i < 5; i++) {
    if (Robot.IRarray[i] < Min) {
      Min = Robot.IRarray[i];
      MinPos = i;
    }
    Serial.print(Robot.IRarray[i]);  //Ausgabe an Serielle Schnittstelle
    Serial.print(" ");               //zur Fehlerbehebung
  }
  Serial.println("");

  if (Min >= 700) {
    //Keine Auffälligkeiten, geradeaus fahren
    LGeschw = Geschwindigkeit;
    RGeschw = Geschwindigkeit;
    Robot.motorsWrite(LGeschw, RGeschw );
  } else {
    //Randmarkierung gefunden
    int Richtung = 1;  
    if (MinPos >= 3 ) {
      Richtung = -1;
    }

    //Roboter stoppen (mit invertierten alten Werten)
    Robot.motorsWrite(-LGeschw, -RGeschw );
    delay(20);

    //Roboter in berechnete Richtung drehen 
    LGeschw = -Geschwindigkeit * Richtung;
    RGeschw = Geschwindigkeit * Richtung;
    Robot.motorsWrite(LGeschw, RGeschw );
    delay(200);
  }
}
