const int pin_button = 5;
const int pin_gnd = 7;

#include <Stepper.h>

const int stepsPerRevolution = 200;  // change this to fit the number of steps per revolution
// for your motor

// initialize the stepper library on pins 8 through 11:
Stepper myStepper(stepsPerRevolution, 12, 13);

void setup() {
  // set the speed at 60 rpm:
  myStepper.setSpeed(1);
  // initialize the serial port:
  Serial.begin(9600);

  pinMode(3, OUTPUT);
  pinMode(11, OUTPUT);

  pinMode(pin_gnd, OUTPUT);
  digitalWrite(pin_gnd, LOW);

  pinMode(pin_button, INPUT);
  digitalWrite(pin_button, HIGH);
}

void doSteps(int steps) {

  myStepper.step(steps);

}
boolean motorOn = false;
void loop() {
  if (!digitalRead(pin_button)) {
    if (motorOn) {
      motorOn = false;
      digitalWrite(3, LOW);
      digitalWrite(11, LOW);
    } else {
      motorOn = true;
      digitalWrite(3, HIGH);
      digitalWrite(11, HIGH);
    }
    delay(250);
  }
  if (motorOn)
    myStepper.step(1);
}

